MacDraft5ParserInternal::Layout Struct Reference documentation

Public Member Functions | Public Attributes | Friends | List of all members
MacDraft5ParserInternal::Layout Struct Reference

Internal and low level: a class used to store layout definition of a MacDraf5Parser. More...

## Public Member Functions
| Layout (int id)
| constructor
bool | isEmpty () const
| returns true if the layout contains no shape
std::shared_ptr< Shape > | findShape (long id, bool normallyExist=true) const
| returns a child corresponding to an id
void | updateRelations ()
| try to check/update the parent relations are compatible with group childs, no loop exist, ...

## Public Attributes
int | m_id
| the layout id
MWAWEntry | m_entry
| the layout position in the data fork
int | m_N
| the number of elements
int | m_objectId
| the object number
librevenge::RVNGString | m_name
| the layout name
std::vector< std::shared_ptr< Shape > > | m_shapeList
| the shapes list
std::vector< size_t > | m_rootList
| the root position list
std::map< long, size_t > | m_idToShapePosMap
| a map id to position in shapeList
std::string | m_extra
| extra data

## Friends
std::ostream & | operator<< (std::ostream &o, Layout const &lay)
| operator<<

## Detailed Description

Internal and low level: a class used to store layout definition of a MacDraf5Parser.

## Constructor & Destructor Documentation

## ◆ Layout()

MacDraft5ParserInternal::Layout::Layout | ( | int | id | ) |
| inlineexplicit

constructor

## Member Function Documentation

## ◆ findShape()

std::shared_ptr< Shape > MacDraft5ParserInternal::Layout::findShape | ( | long | id,
|  | bool | normallyExist = `true`
| ) |  | const
| inline

returns a child corresponding to an id

Referenced by MacDraft5Parser::send().

## ◆ isEmpty()

bool MacDraft5ParserInternal::Layout::isEmpty | ( |  | ) | const
| inline

returns true if the layout contains no shape

## ◆ updateRelations()

void MacDraft5ParserInternal::Layout::updateRelations | ( |  | ) |

try to check/update the parent relations are compatible with group childs, no loop exist, ...

Referenced by MacDraft5Parser::readLayout().

## Friends And Related Function Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | o,
|  | Layout const & | lay
| ) |  |
| friend

operator<<

## Member Data Documentation

## ◆ m_entry

MWAWEntry MacDraft5ParserInternal::Layout::m_entry

the layout position in the data fork

Referenced by MacDraft5Parser::readLayout().

## ◆ m_extra

std::string MacDraft5ParserInternal::Layout::m_extra

extra data

## ◆ m_id

int MacDraft5ParserInternal::Layout::m_id

the layout id

Referenced by MacDraft5Parser::send().

## ◆ m_idToShapePosMap

std::map<long, size_t> MacDraft5ParserInternal::Layout::m_idToShapePosMap

a map id to position in shapeList

Referenced by findShape(), and updateRelations().

## ◆ m_N

int MacDraft5ParserInternal::Layout::m_N

the number of elements

Referenced by MacDraft5Parser::readLayout().

## ◆ m_name

librevenge::RVNGString MacDraft5ParserInternal::Layout::m_name

the layout name

Referenced by MacDraft5Parser::send().

## ◆ m_objectId

int MacDraft5ParserInternal::Layout::m_objectId

the object number

Referenced by MacDraft5Parser::readLayout(), and MacDraft5Parser::readObject().

## ◆ m_rootList

std::vector<size_t> MacDraft5ParserInternal::Layout::m_rootList

the root position list

Referenced by MacDraft5Parser::send(), and updateRelations().

## ◆ m_shapeList

std::vector<std::shared_ptr<Shape> > MacDraft5ParserInternal::Layout::m_shapeList

the shapes list

Referenced by findShape(), isEmpty(), MacDraft5Parser::readObject(), MacDraft5Parser::send(), and updateRelations().

The documentation for this struct was generated from the following file:

- MacDraft5Parser.cxx